hack/release.sh
b1953bab
 #!/usr/bin/env bash
83a2e92d
 set -e
ccc39695
 
d9f76993
 # This script looks for bundles built by make.sh, and releases them on a
 # public S3 bucket.
ccc39695
 #
 # Bundles should be available for the VERSION string passed as argument.
 #
d9f76993
 # The correct way to call this script is inside a container built by the
 # official Dockerfile at the root of the Docker source code. The Dockerfile,
 # make.sh and release.sh should all be from the same source code revision.
ccc39695
 
83a2e92d
 set -o pipefail
ccc39695
 
 # Print a usage message and exit.
 usage() {
83a2e92d
 	cat >&2 <<'EOF'
ff30eb96
 To run, I need:
 - to be in a container generated by the Dockerfile at the top of the Docker
   repository;
 - to be provided with the name of an S3 bucket, in environment variable
   AWS_S3_BUCKET;
 - to be provided with AWS credentials for this S3 bucket, in environment
   variables AWS_ACCESS_KEY and AWS_SECRET_KEY;
9c06420b
 - the passphrase to unlock the GPG key which will sign the deb packages
   (passed as environment variable GPG_PASSPHRASE);
ff30eb96
 - a generous amount of good will and nice manners.
 The canonical way to run me is to run the image produced by the Dockerfile: e.g.:"
 
80825765
 docker run -e AWS_S3_BUCKET=test.docker.com \
            -e AWS_ACCESS_KEY=... \
            -e AWS_SECRET_KEY=... \
            -e GPG_PASSPHRASE=... \
44fe8cbb
            -i -t --privileged \
83a2e92d
            docker ./hack/release.sh
ff30eb96
 EOF
ccc39695
 	exit 1
 }
 
ff30eb96
 [ "$AWS_S3_BUCKET" ] || usage
 [ "$AWS_ACCESS_KEY" ] || usage
 [ "$AWS_SECRET_KEY" ] || usage
9c06420b
 [ "$GPG_PASSPHRASE" ] || usage
b3ee9ac7
 [ -d /go/src/github.com/docker/docker ] || usage
 cd /go/src/github.com/docker/docker
83a2e92d
 [ -x hack/make.sh ] || usage
 
 RELEASE_BUNDLES=(
 	binary
62a81370
 	cross
b3f5973f
 	tgz
83a2e92d
 	ubuntu
 )
 
 if [ "$1" != '--release-regardless-of-test-failure' ]; then
886eb85d
 	RELEASE_BUNDLES=(
e096d567
 		test-unit
886eb85d
 		"${RELEASE_BUNDLES[@]}"
 		test-integration-cli
 	)
83a2e92d
 fi
886eb85d
 
4d53a195
 VERSION=$(< VERSION)
ab4fb9bb
 BUCKET=$AWS_S3_BUCKET
ccc39695
 
179e2c92
 # These are the 2 keys we've used to sign the deb's
80825765
 #   release (get.docker.com)
179e2c92
 #	GPG_KEY="36A1D7869245C8950F966E92D8576A8BA88D21E9"
80825765
 #   test    (test.docker.com)
179e2c92
 #	GPG_KEY="740B314AE3941731B942C66ADF4FD13717AAD7D6"
 
ccc39695
 setup_s3() {
 	# Try creating the bucket. Ignore errors (it might already exist).
ac20568b
 	s3cmd mb "s3://$BUCKET" 2>/dev/null || true
ab4fb9bb
 	# Check access to the bucket.
 	# s3cmd has no useful exit status, so we cannot check that.
 	# Instead, we check if it outputs anything on standard output.
 	# (When there are problems, it uses standard error instead.)
ac20568b
 	s3cmd info "s3://$BUCKET" | grep -q .
0469e476
 	# Make the bucket accessible through website endpoints.
ac20568b
 	s3cmd ws-create --ws-index index --ws-error error "s3://$BUCKET"
ccc39695
 }
 
 # write_to_s3 uploads the contents of standard input to the specified S3 url.
 write_to_s3() {
 	DEST=$1
 	F=`mktemp`
ac20568b
 	cat > "$F"
 	s3cmd --acl-public --mime-type='text/plain' put "$F" "$DEST"
 	rm -f "$F"
ccc39695
 }
 
 s3_url() {
94bf5b00
 	case "$BUCKET" in
80825765
 		get.docker.com|test.docker.com)
94bf5b00
 			echo "https://$BUCKET"
 			;;
 		*)
b8e7ec1b
 			s3cmd ws-info s3://$BUCKET | awk -v 'FS=: +' '/http:\/\/'$BUCKET'/ { gsub(/\/+$/, "", $2); print $2 }'
94bf5b00
 			;;
 	esac
ccc39695
 }
 
179e2c92
 build_all() {
 	if ! ./hack/make.sh "${RELEASE_BUNDLES[@]}"; then
 		echo >&2
 		echo >&2 'The build or tests appear to have failed.'
 		echo >&2
 		echo >&2 'You, as the release  maintainer, now have a couple options:'
 		echo >&2 '- delay release and fix issues'
 		echo >&2 '- delay release and fix issues'
 		echo >&2 '- did we mention how important this is?  issues need fixing :)'
 		echo >&2
 		echo >&2 'As a final LAST RESORT, you (because only you, the release maintainer,'
 		echo >&2 ' really knows all the hairy problems at hand with the current release'
 		echo >&2 ' issues) may bypass this checking by running this script again with the'
 		echo >&2 ' single argument of "--release-regardless-of-test-failure", which will skip'
 		echo >&2 ' running the test suite, and will only build the binaries and packages.  Please'
 		echo >&2 ' avoid using this if at all possible.'
 		echo >&2
 		echo >&2 'Regardless, we cannot stress enough the scarcity with which this bypass'
 		echo >&2 ' should be used.  If there are release issues, we should always err on the'
 		echo >&2 ' side of caution.'
 		echo >&2
 		exit 1
 	fi
 }
 
6b46a091
 upload_release_build() {
 	src="$1"
 	dst="$2"
 	latest="$3"
 
 	echo
 	echo "Uploading $src"
 	echo "  to $dst"
 	echo
 	s3cmd --follow-symlinks --preserve --acl-public put "$src" "$dst"
 	if [ "$latest" ]; then
 		echo
 		echo "Copying to $latest"
 		echo
 		s3cmd --acl-public cp "$dst" "$latest"
 	fi
 
 	# get hash files too (see hash_files() in hack/make.sh)
 	for hashAlgo in md5 sha256; do
 		if [ -e "$src.$hashAlgo" ]; then
 			echo
 			echo "Uploading $src.$hashAlgo"
 			echo "  to $dst.$hashAlgo"
 			echo
 			s3cmd --follow-symlinks --preserve --acl-public --mime-type='text/plain' put "$src.$hashAlgo" "$dst.$hashAlgo"
 			if [ "$latest" ]; then
 				echo
 				echo "Copying to $latest.$hashAlgo"
 				echo
 				s3cmd --acl-public cp "$dst.$hashAlgo" "$latest.$hashAlgo"
 			fi
 		fi
 	done
 }
 
4100e9b7
 release_build() {
 	GOOS=$1
 	GOARCH=$2
 
6b46a091
 	binDir=bundles/$VERSION/cross/$GOOS/$GOARCH
 	tgzDir=bundles/$VERSION/tgz/$GOOS/$GOARCH
 	binary=docker-$VERSION
 	tgz=docker-$VERSION.tgz
 
 	latestBase=
 	if [ -z "$NOLATEST" ]; then
 		latestBase=docker-latest
 	fi
4100e9b7
 
 	# we need to map our GOOS and GOARCH to uname values
 	# see https://en.wikipedia.org/wiki/Uname
 	# ie, GOOS=linux -> "uname -s"=Linux
 
6b46a091
 	s3Os=$GOOS
 	case "$s3Os" in
4100e9b7
 		darwin)
6b46a091
 			s3Os=Darwin
4100e9b7
 			;;
 		freebsd)
6b46a091
 			s3Os=FreeBSD
4100e9b7
 			;;
 		linux)
6b46a091
 			s3Os=Linux
4100e9b7
 			;;
241c3719
 		windows)
 			s3Os=Windows
 			binary+='.exe'
 			if [ "$latestBase" ]; then
 				latestBase+='.exe'
 			fi
 			;;
4100e9b7
 		*)
6b46a091
 			echo >&2 "error: can't convert $s3Os to an appropriate value for 'uname -s'"
4100e9b7
 			exit 1
 			;;
 	esac
 
6b46a091
 	s3Arch=$GOARCH
 	case "$s3Arch" in
4100e9b7
 		amd64)
6b46a091
 			s3Arch=x86_64
4100e9b7
 			;;
 		386)
6b46a091
 			s3Arch=i386
4100e9b7
 			;;
 		arm)
6b46a091
 			s3Arch=armel
065dd231
 			# someday, we might potentially support mutliple GOARM values, in which case we might get armhf here too
4100e9b7
 			;;
 		*)
6b46a091
 			echo >&2 "error: can't convert $s3Arch to an appropriate value for 'uname -m'"
4100e9b7
 			exit 1
 			;;
 	esac
 
6b46a091
 	s3Dir=s3://$BUCKET/builds/$s3Os/$s3Arch
 	latest=
 	latestTgz=
 	if [ "$latestBase" ]; then
 		latest="$s3Dir/$latestBase"
 		latestTgz="$s3Dir/$latestBase.tgz"
 	fi
4100e9b7
 
6b46a091
 	if [ ! -x "$binDir/$binary" ]; then
 		echo >&2 "error: can't find $binDir/$binary - was it compiled properly?"
4100e9b7
 		exit 1
 	fi
6b46a091
 	if [ ! -f "$tgzDir/$tgz" ]; then
 		echo >&2 "error: can't find $tgzDir/$tgz - was it packaged properly?"
4100e9b7
 		exit 1
 	fi
 
6b46a091
 	upload_release_build "$binDir/$binary" "$s3Dir/$binary" "$latest"
 	upload_release_build "$tgzDir/$tgz" "$s3Dir/$tgz" "$latestTgz"
4100e9b7
 }
 
ccc39695
 # Upload the 'ubuntu' bundle to S3:
 # 1. A full APT repository is published at $BUCKET/ubuntu/
f56945d7
 # 2. Instructions for using the APT repository are uploaded at $BUCKET/ubuntu/index
ccc39695
 release_ubuntu() {
ac20568b
 	[ -e "bundles/$VERSION/ubuntu" ] || {
83a2e92d
 		echo >&2 './hack/make.sh must be run before release_ubuntu'
 		exit 1
 	}
9c06420b
 
b3adf94d
 	local debfiles=( "bundles/$VERSION/ubuntu/"*.deb )
 
9c06420b
 	# Sign our packages
b3adf94d
 	dpkg-sig -g "--passphrase $GPG_PASSPHRASE" -k releasedocker --sign builder "${debfiles[@]}"
9c06420b
 
5b0eaef6
 	# Setup the APT repo
 	APTDIR=bundles/$VERSION/ubuntu/apt
ac20568b
 	mkdir -p "$APTDIR/conf" "$APTDIR/db"
 	s3cmd sync "s3://$BUCKET/ubuntu/db/" "$APTDIR/db/" || true
 	cat > "$APTDIR/conf/distributions" <<EOF
5b0eaef6
 Codename: docker
 Components: main
87872006
 Architectures: amd64 i386
5b0eaef6
 EOF
 
 	# Add the DEB package to the APT repo
b3adf94d
 	reprepro -b "$APTDIR" includedeb docker "${debfiles[@]}"
5b0eaef6
 
9c06420b
 	# Sign
83a2e92d
 	for F in $(find $APTDIR -name Release); do
ac20568b
 		gpg -u releasedocker --passphrase "$GPG_PASSPHRASE" \
9c06420b
 			--armor --sign --detach-sign \
ac20568b
 			--output "$F.gpg" "$F"
9c06420b
 	done
 
 	# Upload keys
ac20568b
 	s3cmd sync "$HOME/.gnupg/" "s3://$BUCKET/ubuntu/.gnupg/"
 	gpg --armor --export releasedocker > "bundles/$VERSION/ubuntu/gpg"
 	s3cmd --acl-public put "bundles/$VERSION/ubuntu/gpg" "s3://$BUCKET/gpg"
9c06420b
 
440eb7fe
 	local gpgFingerprint=36A1D7869245C8950F966E92D8576A8BA88D21E9
 	if [[ $BUCKET == test* ]]; then
 		gpgFingerprint=740B314AE3941731B942C66ADF4FD13717AAD7D6
 	fi
 
9c06420b
 	# Upload repo
ac20568b
 	s3cmd --acl-public sync "$APTDIR/" "s3://$BUCKET/ubuntu/"
f56945d7
 	cat <<EOF | write_to_s3 s3://$BUCKET/ubuntu/index
dc7fefc1
 # Check that HTTPS transport is available to APT
 if [ ! -e /usr/lib/apt/methods/https ]; then
 	apt-get update
 	apt-get install -y apt-transport-https
 fi
9f61e233
 
9c06420b
 # Add the repository to your APT sources
94bf5b00
 echo deb $(s3_url)/ubuntu docker main > /etc/apt/sources.list.d/docker.list
9f61e233
 
9c06420b
 # Then import the repository key
f058e9c4
 apt-key adv --keyserver hkp://p80.pool.sks-keyservers.net:80 --recv-keys $gpgFingerprint
9f61e233
 
9c06420b
 # Install docker
fc637b52
 apt-get update
 apt-get install -y lxc-docker
83a2e92d
 
 #
 # Alternatively, just use the curl-able install.sh script provided at $(s3_url)
 #
ccc39695
 EOF
f56945d7
 
 	# Add redirect at /ubuntu/info for URL-backwards-compatibility
 	rm -rf /tmp/emptyfile && touch /tmp/emptyfile
ac20568b
 	s3cmd --acl-public --add-header='x-amz-website-redirect-location:/ubuntu/' --mime-type='text/plain' put /tmp/emptyfile "s3://$BUCKET/ubuntu/info"
f56945d7
 
 	echo "APT repository uploaded. Instructions available at $(s3_url)/ubuntu"
ccc39695
 }
 
4100e9b7
 # Upload binaries and tgz files to S3
 release_binaries() {
ac20568b
 	[ -e "bundles/$VERSION/cross/linux/amd64/docker-$VERSION" ] || {
4100e9b7
 		echo >&2 './hack/make.sh must be run before release_binaries'
b3f5973f
 		exit 1
 	}
 
4100e9b7
 	for d in bundles/$VERSION/cross/*/*; do
 		GOARCH="$(basename "$d")"
 		GOOS="$(basename "$(dirname "$d")")"
 		release_build "$GOOS" "$GOARCH"
 	done
b3f5973f
 
4100e9b7
 	# TODO create redirect from builds/*/i686 to builds/*/i386
f56945d7
 
 	cat <<EOF | write_to_s3 s3://$BUCKET/builds/index
ccc39695
 # To install, run the following command as root:
9f61e233
 curl -sSL -O $(s3_url)/builds/Linux/x86_64/docker-$VERSION && chmod +x docker-$VERSION && sudo mv docker-$VERSION /usr/local/bin/docker
ccc39695
 # Then start docker in daemon mode:
 sudo /usr/local/bin/docker -d
 EOF
f56945d7
 
 	# Add redirect at /builds/info for URL-backwards-compatibility
 	rm -rf /tmp/emptyfile && touch /tmp/emptyfile
ac20568b
 	s3cmd --acl-public --add-header='x-amz-website-redirect-location:/builds/' --mime-type='text/plain' put /tmp/emptyfile "s3://$BUCKET/builds/info"
f56945d7
 
ccc39695
 	if [ -z "$NOLATEST" ]; then
 		echo "Advertising $VERSION on $BUCKET as most recent version"
ac20568b
 		echo "$VERSION" | write_to_s3 "s3://$BUCKET/latest"
ccc39695
 	fi
 }
 
0469e476
 # Upload the index script
 release_index() {
ac20568b
 	sed "s,url='https://get.docker.com/',url='$(s3_url)/'," hack/install.sh | write_to_s3 "s3://$BUCKET/index"
0469e476
 }
 
59856a20
 release_test() {
 	if [ -e "bundles/$VERSION/test" ]; then
ac20568b
 		s3cmd --acl-public sync "bundles/$VERSION/test/" "s3://$BUCKET/test/"
59856a20
 	fi
 }
 
179e2c92
 setup_gpg() {
 	# Make sure that we have our keys
ac20568b
 	mkdir -p "$HOME/.gnupg/"
 	s3cmd sync "s3://$BUCKET/ubuntu/.gnupg/" "$HOME/.gnupg/" || true
179e2c92
 	gpg --list-keys releasedocker >/dev/null || {
 		gpg --gen-key --batch <<EOF
 Key-Type: RSA
6b46a091
 Key-Length: 4096
179e2c92
 Passphrase: $GPG_PASSPHRASE
 Name-Real: Docker Release Tool
b3ee9ac7
 Name-Email: docker@docker.com
179e2c92
 Name-Comment: releasedocker
 Expire-Date: 0
 %commit
 EOF
 	}
 }
 
ccc39695
 main() {
179e2c92
 	build_all
ccc39695
 	setup_s3
179e2c92
 	setup_gpg
4100e9b7
 	release_binaries
ccc39695
 	release_ubuntu
0469e476
 	release_index
59856a20
 	release_test
ccc39695
 }
 
 main
4100e9b7
 
 echo
 echo
 echo "Release complete; see $(s3_url)"
 echo